jjb: build modules against full kernel builds
authorMichael Jeanson <mjeanson@efficios.com>
Thu, 21 Feb 2019 16:09:44 +0000 (11:09 -0500)
committerMichael Jeanson <mjeanson@efficios.com>
Thu, 21 Feb 2019 16:09:44 +0000 (11:09 -0500)
Signed-off-by: Michael Jeanson <mjeanson@efficios.com>
jobs/lttng-modules.yaml
scripts/lttng-modules/master-rt.groovy
scripts/lttng-modules/master.groovy
scripts/lttng-modules/param-build.sh

index 3dcfd1beca1919c710b22c1add28bf28668939d1..ea5b101151fd296e3de6ac927c410228f6be82d5 100644 (file)
@@ -29,7 +29,7 @@
           description: 'The linux kernel git repository url.'
       - string:
           name: 'kbuildjob'
-          default: 'lttng-modules_VERSION_param-{parambuildtype}'
+          default: 'lttng-modules_PARAM_{parambuildtype}'
           description: 'The parametrized job to use for child builds.'
 
 - lttng-modules_build_parameters_ubuntu: &lttng-modules_build_parameters_ubuntu
@@ -61,7 +61,7 @@
           description: 'The linux kernel git repository url.'
       - string:
           name: 'kbuildjob'
-          default: 'lttng-modules_VERSION_param-{parambuildtype}'
+          default: 'lttng-modules_PARAM_{parambuildtype}'
           description: 'The parametrized job to use for child builds.'
       - string:
           name: 'uversion'
@@ -97,7 +97,7 @@
           description: 'The linux kernel git repository url.'
       - string:
           name: 'kbuildjob'
-          default: 'lttng-modules_VERSION_param-build'
+          default: 'lttng-modules_PARAM_build'
           description: 'The parametrized job to use for child builds.'
 
 - lttng-modules_build_builders_defaults: &lttng-modules_build_builders_defaults
     <<: *lttng-modules_build_rt_builders_defaults
 
 - job-template:
-    name: lttng-modules_VERSION_param-build
+    name: lttng-modules_PARAM_build
     defaults: lttng-modules
     description: |
       This is a parametrized job used by 'master' jobs to build any combinations
           name: 'mversion'
           default: 'master'
           description: 'The lttng-modules branch to build.'
+      - string:
+          name: 'mgitrepo'
+          default: 'git://github.com/lttng/lttng-modules.git'
+          description: 'The lttng-modules git repository url.'
       - string:
           name: 'ktag'
           default: ''
 
     concurrent: true
 
-    scm:
-      - git:
-          url: git://github.com/lttng/lttng-modules.git
-          browser: githubweb
-          browser-url: https://github.com/lttng/lttng-modules
-          branches:
-            - "${{mversion}}"
-          skip-tag: true
-          basedir: src/lttng-modules
+    scm: []
 
     triggers:
 
     builders:
-      - shell: |
-          git clone --depth=1 -b "$ktag" --reference $HOME/gitcache/linux-stable.git/ "$kgitrepo" src/linux
       - shell:
           !include-raw-escape: scripts/lttng-modules/param-build.sh
 
     publishers:
       - workspace-cleanup
 
+
 - job-template:
-    name: lttng-modules_VERSION_param-crossbuild
+    name: lttng-modules_PARAM_crossbuild
     defaults: lttng-modules
     description: |
       This is a parametrized job used by 'master' jobs to build any combinations
           name: 'mversion'
           default: 'master'
           description: 'The lttng-modules branch to build.'
+      - string:
+          name: 'mgitrepo'
+          default: 'git://github.com/lttng/lttng-modules.git'
+          description: 'The lttng-modules git repository url.'
       - string:
           name: 'ktag'
           default: ''
 
     concurrent: true
 
-    scm:
-      - git:
-          url: git://github.com/lttng/lttng-modules.git
-          browser: githubweb
-          browser-url: https://github.com/lttng/lttng-modules
-          branches:
-            - "${{mversion}}"
-          skip-tag: true
-          basedir: src/lttng-modules
+    scm: []
 
     triggers:
 
     builders:
-      - shell: |
-          git clone --depth=1 -b "$ktag" --reference $HOME/gitcache/linux-stable.git/ "$kgitrepo" src/linux
       - shell:
           !include-raw-escape: scripts/lttng-modules/param-build.sh
+
     publishers:
       - workspace-cleanup
 
     jobs:
 
 # Vanilla normal builds
+      - 'lttng-modules_{mversion}_{buildtype}-vanilla':
+          mversion:
+            - master
+          buildtype: build
+          parambuildtype: build
+          kverfloor: v3.0
+          kverceil: ''
+          kverfilter: stable-head
       - 'lttng-modules_{mversion}_{buildtype}-vanilla':
           mversion:
             - stable-2.9
             - stable-2.10
             - stable-2.11
-            - master
           buildtype: build
           parambuildtype: build
           kverfloor: v2.6.36
           kverfloor: v2.6.36
           kverceil: v4.8-rc0
           kverfilter: stable-head
+      - 'lttng-modules_{mversion}_fullbuild-vanilla':
+          mversion:
+            - master
+          buildtype: build
+          parambuildtype: build
+          kverfloor: v3.0
+          kverceil: ''
+          kverfilter: none
       - 'lttng-modules_{mversion}_fullbuild-vanilla':
           mversion:
             - stable-2.9
             - stable-2.10
             - stable-2.11
-            - master
           buildtype: build
           parambuildtype: build
           kverfloor: v2.6.36
           kverfilter: stable-head
 
 # Parametrized kernel and modules build jobs
-      - 'lttng-modules_VERSION_param-build':
+      - 'lttng-modules_PARAM_build':
           arch: !!python/tuple [x86-32, x86-64]
-      - 'lttng-modules_VERSION_param-crossbuild':
+      - 'lttng-modules_PARAM_crossbuild':
           cross_arch: !!python/tuple [armhf, arm64, powerpc, ppc64el]
 
 # Misc jobs
index 0e94ee48d5013323cb7e42fe36eeed1968414ac1..5f634ed5a9e9fa4875b4103bce1f3816c427db06 100644 (file)
@@ -1,5 +1,5 @@
 /**
- * Copyright (C) 2016-2017 - Michael Jeanson <mjeanson@efficios.com>
+ * Copyright (C) 2016-2018 - Michael Jeanson <mjeanson@efficios.com>
  *
  * This program is free software: you can redistribute it and/or modify
  * it under the terms of the GNU General Public License as published by
@@ -166,7 +166,7 @@ def kverceil_raw = build.buildVariableResolver.resolve('kverceil')
 def kverfilter = build.buildVariableResolver.resolve('kverfilter')
 def job = Hudson.instance.getJob(build.buildVariableResolver.resolve('kbuildjob'))
 def currentJobName = build.project.getFullDisplayName()
-
+def gitmodpath = build.getEnvironment(listener).get('WORKSPACE') + "/src/lttng-modules"
 
 // Get the out variable
 def config = new HashMap()
@@ -175,8 +175,12 @@ config.putAll(bindings.getVariables())
 def out = config['out']
 
 
+// Get the lttng-modules git url
+def gitmodrepo = Git.open(new File(gitmodpath))
+def mgitrepo = gitmodrepo.getRepository().getConfig().getString("remote", "origin", "url")
+
 // Get tags from git repository
-def refs = Git.lsRemoteRepository().setTags(true).setRemote(kgitrepo).call();
+def refs = Git.lsRemoteRepository().setTags(true).setRemote(kgitrepo).call()
 
 // Get kernel versions to build
 def kversions = []
@@ -299,6 +303,7 @@ while ( kversions.size() != 0 || ongoingBuild.size() != 0 ) {
     def kversion = kversions.pop()
     def job_params = [
       new StringParameterValue('mversion', mversion),
+      new StringParameterValue('mgitrepo', mgitrepo),
       new StringParameterValue('ktag', kversion.toString()),
       new StringParameterValue('kgitrepo', kgitrepo),
     ]
index 20b2f48712eaca740946e86132c14800c05606d0..0b5d9ee2b93c5458837c63b8ce1e024ae8240192 100644 (file)
@@ -1,5 +1,5 @@
 /**
- * Copyright (C) 2016-2017 - Michael Jeanson <mjeanson@efficios.com>
+ * Copyright (C) 2016-2018 - Michael Jeanson <mjeanson@efficios.com>
  *
  * This program is free software: you can redistribute it and/or modify
  * it under the terms of the GNU General Public License as published by
@@ -308,7 +308,7 @@ def kverfilter = build.buildVariableResolver.resolve('kverfilter')
 def uversion = build.buildVariableResolver.resolve('uversion')
 def job = Hudson.instance.getJob(build.buildVariableResolver.resolve('kbuildjob'))
 def currentJobName = build.project.getFullDisplayName()
-
+def gitmodpath = build.getEnvironment(listener).get('WORKSPACE') + "/src/lttng-modules"
 
 // Get the out variable
 def config = new HashMap()
@@ -317,8 +317,12 @@ config.putAll(bindings.getVariables())
 def out = config['out']
 
 
+// Get the lttng-modules git url
+def gitmodrepo = Git.open(new File(gitmodpath))
+def mgitrepo = gitmodrepo.getRepository().getConfig().getString("remote", "origin", "url")
+
 // Get tags from git repository
-def refs = Git.lsRemoteRepository().setTags(true).setRemote(kgitrepo).call();
+def refs = Git.lsRemoteRepository().setTags(true).setRemote(kgitrepo).call()
 
 // Get kernel versions to build
 def kversions = []
@@ -457,6 +461,7 @@ while ( kversions.size() != 0 || ongoingBuild.size() != 0 ) {
     def kversion = kversions.pop()
     def job_params = [
       new StringParameterValue('mversion', mversion),
+      new StringParameterValue('mgitrepo', mgitrepo),
       new StringParameterValue('ktag', kversion.toString()),
       new StringParameterValue('kgitrepo', kgitrepo),
     ]
index 405c61f0ee87dc4a87d67142977e35935facd558..7f965b47b712a2ea9b2f46648cd44e217e36d6cb 100644 (file)
@@ -1,6 +1,6 @@
-#!/bin/sh -exu
+#!/bin/bash -exu
 #
-# Copyright (C) 2016 - Michael Jeanson <mjeanson@efficios.com>
+# Copyright (C) 2016-2018 - Michael Jeanson <mjeanson@efficios.com>
 #
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -19,6 +19,9 @@
 arch=${arch:-}
 cross_arch=${cross_arch:-}
 ktag=${ktag:-}
+kgitrepo=${kgitrepo:-}
+mversion=${mversion:-}
+mgitrepo=${mgitrepo:-}
 
 
 ## FUNCTIONS ##
@@ -41,48 +44,174 @@ vergt() {
 }
 
 
-prepare_lnx_sources() {
+git_clone_modules_sources() {
+    mkdir -p "$MODULES_GIT_DIR"
+    git clone --depth=1 -b "${mversion}" "${mgitrepo}" "$MODULES_GIT_DIR"
+}
+
+# Checkout a shallow kernel tree of the specified tag
+git_clone_linux_sources() {
+    mkdir -p "$LINUX_GIT_DIR"
+    git clone --depth=1 -b "${ktag}" --reference "$LINUX_GIT_REF_REPO_DIR" "${kgitrepo}" "$LINUX_GIT_DIR"
+}
 
-    outdir=$1
 
-    if [ "$outdir" = "." ]; then
-      koutput=""
-    else
-      koutput="O=${outdir}"
+# Export the kernel sources from the git repo
+git_export_linux_sources() {
+    cd "$LINUX_GIT_DIR"
+    git archive "${ktag}" | tar -x -C "$LINUX_SRCOBJ_DIR"
+}
+
+
+# Upload the tar archive to the object store
+upload_archive_obj() {
+    s3cmd -c "$WORKSPACE/.s3cfg" put "$WORKSPACE/$obj_name" "$obj_url_prefix/"
+    rm -f "$WORKSPACE/$obj_name"
+}
+
+
+extract_archive_obj() {
+    tar -xf "$WORKSPACE/$obj_name" -C "$LINUX_OBJ_DIR"
+    rm -f "$WORKSPACE/$obj_name"
+}
+
+
+tar_archive_obj() {
+    cd "$LINUX_OBJ_DIR"
+    tar -cf "$WORKSPACE/$obj_name" -I pbzip2 .
+    cd -
+}
+
+# Find the most recent GCC version supported by the kernel sources
+select_compiler() {
+    local selected_cc
+
+    cd "$LINUX_SRCOBJ_DIR"
+
+    kversion=$(make -s kernelversion)
+
+    set +e
+
+    for cc in gcc-7 gcc-5 gcc-4.9; do
+      if "${CROSS_COMPILE:-}${cc}" -I include/ -D__LINUX_COMPILER_H -D__LINUX_COMPILER_TYPES_H -E include/linux/compiler-gcc.h; then
+        selected_cc="$cc"
+        break
+      fi
+    done
+
+    set -e
+
+    if [ "x$selected_cc" = "x" ]; then
+      echo "Found no suitable compiler."
+      exit 1
+    fi
+
+    # Force gcc-4 for buggy kernel branches
+    if { vergte "$kversion" "3.2" && verlt "$kversion" "3.3"; } || \
+       { vergte "$kversion" "3.4" && verlt "$kversion" "3.5"; } || \
+       { vergte "$kversion" "3.17" && verlt "$kversion" "3.18"; }; then
+      selected_cc=gcc-4.9
     fi
 
+    case "$ktag" in
+      Ubuntu*)
+        if { vergte "$kversion" "3.13" && verlt "$kversion" "3.14"; }; then
+          selected_cc=gcc-4.9
+        fi
+      ;;
+    esac
+
+    export CC="${CROSS_COMPILE:-}${selected_cc}"
+
+    cd -
+}
+
+
+build_linux_kernel() {
+    cd "$LINUX_SRCOBJ_DIR"
+
+    kversion=$(make -s kernelversion)
+
     # Generate kernel configuration
     case "$ktag" in
       Ubuntu*)
         if [ "${cross_arch}" = "powerpc" ]; then
-          if vergte "$KVERSION" "4.10"; then
+          if vergte "${kversion}" "4.10"; then
             echo "Ubuntu removed big endian powerpc configuration from kernel >= 4.10. Don't try to build it."
             exit 0
           fi
         fi
         fakeroot debian/rules clean
         fakeroot debian/rules genconfigs
-        cp CONFIGS/"${ubuntu_config}" "${outdir}"/.config
+        cp CONFIGS/"${ubuntu_config}" .config
         ;;
       *)
         # Force 32bit build on x86-32, default is 64bit
         if [ "$arch" = "x86-32" ]; then
-         export ARCH="i386"
+            export ARCH="i386"
+        fi
+
+        # allyesconfig is mostly broken for kernels of the 2.6 series
+        if verlt "$kversion" "3.0"; then
+            vanilla_config="defconfig"
         fi
 
-        # Que sera sera
-        make "${vanilla_config}" CC="$CC" ${koutput}
+        make "${vanilla_config}"
         ;;
     esac
 
+    # silentoldconfig was renamed in 4.19
+    if vergte "$kversion" "4.19"; then
+        update_conf_target="syncconfig"
+    else
+        update_conf_target="silentoldconfig"
+    fi
+
+    # Fix 'defined(@array)' was removed from recent perl
+    if [ -f "kernel/timeconst.pl" ]; then
+      sed -i 's/defined(\@\(.*\))/@\1/' kernel/timeconst.pl
+    fi
+
+    # Fix syntax of inline assembly which is confused with C++11 raw strings on gcc >= 5
+    if [ "$CC" != "gcc-4.9" ]; then
+      if [ -f "arch/x86/kvm/svm.c" ]; then
+        sed -i 's/ R"/ R "/g; s/"R"/" R "/g' arch/x86/kvm/svm.c
+      fi
+
+      if [ -f "arch/x86/kvm/vmx.c" ]; then
+        sed -i 's/ R"/ R "/g; s/"R"/" R "/g' arch/x86/kvm/vmx.c
+      fi
+    fi
+
+    # Fix a typo in v2.6.36.x
+    if [ -f "arch/x86/kernel/entry_64.S" ]; then
+      sed -i 's/END(do_hypervisor_callback)/END(xen_do_hypervisor_callback)/' arch/x86/kernel/entry_64.S
+    fi
+
+    # Fix kernel < 3.0 with gcc >= 4.7
+    if verlt "$kversion" "3.0"; then
+      sed -i '/linux\/compiler.h/a #include <linux\/linkage.h> \/* For asmregparm *\/' arch/x86/include/asm/ptrace.h
+      sed -i 's/extern long syscall_trace_enter/extern asmregparm long syscall_trace_enter/' arch/x86/include/asm/ptrace.h
+      sed -i 's/extern void syscall_trace_leave/extern asmregparm void syscall_trace_leave/' arch/x86/include/asm/ptrace.h
+      echo "header-y += linkage.h" >> include/linux/Kbuild
+    fi
+
     # GCC 4.8
-    sed -i "s/CONFIG_CC_STACKPROTECTOR_STRONG=y/# CONFIG_CC_STACKPROTECTOR_STRONG is not set/g" "${outdir}"/.config
+    sed -i "s/CONFIG_CC_STACKPROTECTOR_STRONG=y/# CONFIG_CC_STACKPROTECTOR_STRONG is not set/g" .config
 
     # Don't try to sign modules
-    sed -i "s/CONFIG_MODULE_SIG=y/# CONFIG_MODULE_SIG is not set/g" "${outdir}"/.config
+    sed -i "s/CONFIG_MODULE_SIG=y/# CONFIG_MODULE_SIG is not set/g" .config
 
     # Disable kernel stack frame correctness validation, introduced in 4.6.0 and currently fails
-    sed -i "s/CONFIG_STACK_VALIDATION=y/# CONFIG_STACK_VALIDATION is not set/g" "${outdir}"/.config
+    sed -i "s/CONFIG_STACK_VALIDATION=y/# CONFIG_STACK_VALIDATION is not set/g" .config
+
+    # Cause problems with inline assembly on i386
+    sed -i "s/CONFIG_DEBUG_SECTION_MISMATCH=y/# CONFIG_DEBUG_SECTION_MISMATCH is not set/g" .config
+
+    # IGBVF won't build with recent gcc on 2.6.38.x
+    if { vergte "$kversion" "2.6.37" && verlt "$kversion" "2.6.38"; }; then
+      sed -i "s/CONFIG_IGBVF=y/# CONFIG_IGBVF is not set/g" .config
+    fi
 
     # Set required options
     {
@@ -91,23 +220,128 @@ prepare_lnx_sources() {
         echo "CONFIG_BLK_DEV_IO_TRACE=y";
         echo "CONFIG_TRACEPOINTS=y";
         echo "CONFIG_KALLSYMS_ALL=y";
-    } >> "${outdir}"/.config
+    } >> .config
 
     # Debug
-    #cat "${outdir}"/.config
+    #cat .config
+
+    make "$update_conf_target" CC="$CC"
+    make -j"$NPROC" CC="$CC"
+
+    krelease=$(make -s kernelrelease)
+
+    # Save the kernel and modules
+    mkdir -p "$LINUX_INSTOBJ_DIR/boot"
+    make INSTALL_MOD_PATH="$LINUX_INSTOBJ_DIR" INSTALL_MOD_STRIP=1 modules_install
+    make INSTALL_PATH="$LINUX_INSTOBJ_DIR/boot" install
+    rm -f "$LINUX_INSTOBJ_DIR/lib/modules/${krelease}/source" "$LINUX_INSTOBJ_DIR/lib/modules/${krelease}/build"
+    ln -s ../../../../sources "$LINUX_INSTOBJ_DIR/lib/modules/${krelease}/source"
+    ln -s ../../../../sources "$LINUX_INSTOBJ_DIR/lib/modules/${krelease}/source"
+}
+
+
+extract_distro_headers() {
+
+    # Enter linux source dir
+    cd "${LINUX_SRCOBJ_DIR}"
+
+
+    # For RT kernels, copy version file
+    if [ -s localversion-rt ]; then
+        cp -a localversion-rt "${LINUX_HDROBJ_DIR}"
+    fi
+
+    # Copy all Makefile related stuff
+    find . -path './include/*' -prune \
+        -o -path './scripts/*' -prune -o -type f \
+        \( -name 'Makefile*' -o -name 'Kconfig*' -o -name 'Kbuild*' -o \
+            -name '*.sh' -o -name '*.pl' -o -name '*.lds' \) \
+        -print | cpio -pd --preserve-modification-time "${LINUX_HDROBJ_DIR}"
+
+    # Copy base scripts and include dirs
+    cp -a scripts include "${LINUX_HDROBJ_DIR}"
 
-    make "$oldconf_target" CC="$CC" ${koutput}
-    make modules_prepare CC="$CC" ${koutput}
+    # Copy arch includes
+    (find arch -name include -type d -print0 | \
+        xargs -0 -n1 -i: find : -type f) | \
+        cpio -pd --preserve-modification-time "${LINUX_HDROBJ_DIR}"
+
+    # Copy arch scripts
+    (find arch -name scripts -type d -print0 | \
+        xargs -0 -n1 -i: find : -type f) | \
+        cpio -pd --preserve-modification-time "${LINUX_HDROBJ_DIR}"
+
+    # Cleanup scripts
+    rm -f "${LINUX_HDROBJ_DIR}/scripts/*.o"
+    rm -f "${LINUX_HDROBJ_DIR}/scripts/*/*.o"
+
+    # On powerpc this object is required to link modules
+    if [ "${karch}" = "powerpc" ]; then
+        cp -a --parents arch/powerpc/lib/crtsavres.[So] "${LINUX_HDROBJ_DIR}/"
+    fi
+
+    # On arm64 between 4.13 and 1.15 this object is required to build with ftrace support
+    if [ "${karch}" = "arm64" ]; then
+        if [ -f "arch/arm64/kernel/ftrace-mod.S" ]; then
+            cp -a --parents arch/arm64/kernel/ftrace-mod.[So] "${LINUX_HDROBJ_DIR}/"
+        fi
+    fi
+
+    # Newer kernels need objtool to build modules when CONFIG_STACK_VALIDATION=y
+    if [ -f tools/objtool/objtool ]; then
+      cp -a --parents tools/objtool/objtool "${LINUX_HDROBJ_DIR}/"
+    fi
+
+    if [ -f "arch/x86/kernel/macros.s" ]; then
+      cp -a --parents arch/x86/kernel/macros.s "${LINUX_HDROBJ_DIR}/"
+    fi
+
+    # Copy modules related stuff, if available
+    if [ -s Module.symvers ]; then
+        cp Module.symvers "${LINUX_HDROBJ_DIR}"
+    fi
+
+    if [ -s System.map ]; then
+        cp System.map "${LINUX_HDROBJ_DIR}"
+    fi
+
+    if [ -s Module.markers ]; then
+        cp Module.markers "${LINUX_HDROBJ_DIR}"
+    fi
+
+    # Copy config file
+    cp .config "${LINUX_HDROBJ_DIR}"
+
+    # Make sure the Makefile and version.h have a matching timestamp so that
+    # external modules can be built
+    if [ -s "${LINUX_HDROBJ_DIR}/include/generated/uapi/linux/version.h" ]; then
+        touch -r "${LINUX_HDROBJ_DIR}/Makefile" "${LINUX_HDROBJ_DIR}/include/generated/uapi/linux/version.h"
+    elif [ -s "${LINUX_HDROBJ_DIR}/include/linux/version.h" ]; then
+        touch -r "${LINUX_HDROBJ_DIR}/Makefile" "${LINUX_HDROBJ_DIR}/include/linux/version.h"
+    else
+        echo "Missing version.h"
+        exit 1
+    fi
+    touch -r "${LINUX_HDROBJ_DIR}/.config" "${LINUX_HDROBJ_DIR}/include/generated/autoconf.h"
+
+    # Copy .config to include/config/auto.conf so "make prepare" is unnecessary.
+    cp "${LINUX_HDROBJ_DIR}/.config" "${LINUX_HDROBJ_DIR}/include/config/auto.conf"
+
+    # Finally clean the object files from the full source tree
+    make clean
+
+    # And regen the modules support files
+    make modules_prepare CC="$CC"
 
     # On powerpc this object is required to link modules
     if [ "${karch}" = "powerpc" ]; then
-        make arch/powerpc/lib/crtsavres.o CC="$CC" ${koutput}
+        make arch/powerpc/lib/crtsavres.o CC="$CC"
     fi
 
     # On arm64 between 4.13 and 4.15 this object is required to build with ftrace support
     if [ "${karch}" = "arm64" ]; then
         if [ -f "arch/arm64/kernel/ftrace-mod.S" ]; then
-            make arch/arm64/kernel/ftrace-mod.o CC="$CC" ${koutput}
+            make arch/arm64/kernel/ftrace-mod.o CC="$CC"
         fi
     fi
 
@@ -116,31 +350,36 @@ prepare_lnx_sources() {
       Ubuntu*)
         # Add Ubuntu ABI number to kernel headers, this is normally done by the packaging code
         ABINUM="$(echo "$ktag" | grep -P -o 'Ubuntu-(lts-)?.*-\K\d+(?=\..*)')"
-        echo "#define UTS_UBUNTU_RELEASE_ABI $ABINUM" >> "${outdir}"/include/generated/utsrelease.h
+        echo "#define UTS_UBUNTU_RELEASE_ABI $ABINUM" >> include/generated/utsrelease.h
+        echo "#define UTS_UBUNTU_RELEASE_ABI $ABINUM" >> "${LINUX_HDROBJ_DIR}/include/generated/utsrelease.h"
         ;;
     esac
 }
 
 
-
 build_modules() {
 
-    kdir="$1"
-    bdir="$2"
+    local kdir="$1"
+    local outdir="$2"
+    local kversion
+
+    kversion=$(make -C "$LINUX_HDROBJ_DIR" -s kernelversion)
 
     # Enter lttng-modules source dir
-    cd "${LTTSRCDIR}"
+    cd "${MODULES_GIT_DIR}"
 
     # kernels 3.10 to 3.10.13 and 3.11 to 3.11.2 introduce a deadlock in the
     # timekeeping subsystem. We want those build to fail.
-    if { vergte "$KVERSION" "3.10" && verlte "$KVERSION" "3.10.13"; } || \
-       { vergte "$KVERSION" "3.11" && verlte "$KVERSION" "3.11.2"; }; then
+    if { vergte "$kversion" "3.10" && verlte "$kversion" "3.10.13"; } || \
+       { vergte "$kversion" "3.11" && verlte "$kversion" "3.11.2"; }; then
 
         set +e
 
         # Build modules
         KERNELDIR="${kdir}" make -j"${NPROC}" V=1 CC="$CC"
 
+        set -e
+
         # We expect this build to fail, if it doesn't, fail the job.
         if [ "$?" -eq 0 ]; then
             echo "This build should have failed."
@@ -148,11 +387,11 @@ build_modules() {
         fi
 
         # We have to publish at least one file or the build will fail
-        echo "This kernel is broken, there is a deadlock in the timekeeping subsystem." > "${bdir}/BROKEN.txt.ko"
+        echo "This kernel is broken, there is a deadlock in the timekeeping subsystem." > "${outdir}/BROKEN.txt.ko"
 
         set -e
 
-        KERNELDIR="${kdir}" make clean CC="$CC"
+        KERNELDIR="${kdir}" make clean
 
     else # Regular build
 
@@ -160,10 +399,10 @@ build_modules() {
         KERNELDIR="${kdir}" make -j"${NPROC}" V=1 CC="$CC"
 
         # Install modules to build dir
-        KERNELDIR="${kdir}" make INSTALL_MOD_PATH="${bdir}" modules_install CC="$CC"
+        KERNELDIR="${kdir}" make INSTALL_MOD_PATH="${outdir}" modules_install
 
         # Clean build dir
-        KERNELDIR="${kdir}" make clean CC="$CC"
+        KERNELDIR="${kdir}" make clean
     fi
 }
 
@@ -173,15 +412,27 @@ build_modules() {
 # Use all CPU cores
 NPROC=$(nproc)
 
-LTTSRCDIR="${WORKSPACE}/src/lttng-modules"
-LNXSRCDIR="${WORKSPACE}/src/linux"
+MODULES_GIT_DIR="${WORKSPACE}/src/lttng-modules"
+LINUX_GIT_DIR="${WORKSPACE}/src/linux"
 
-LNXBUILDDIR="${WORKSPACE}/build/linux"
-LNXHDRDIR="${WORKSPACE}/build/linux-headers"
+LINUX_OBJ_DIR="${WORKSPACE}/linux"
+LINUX_SRCOBJ_DIR="${LINUX_OBJ_DIR}/sources"
+LINUX_HDROBJ_DIR="${LINUX_OBJ_DIR}/headers"
+LINUX_INSTOBJ_DIR="${LINUX_OBJ_DIR}/install"
 
-LTTBUILDKSRCDIR="${WORKSPACE}/build/lttng-modules-ksrc"
-LTTBUILDKHDRDIR="${WORKSPACE}/build/lttng-modules-khdr"
+MODULES_OUTPUT_KSRC_DIR="${WORKSPACE}/build/lttng-modules-ksrc"
+MODULES_OUTPUT_KHDR_DIR="${WORKSPACE}/build/lttng-modules-khdr"
 
+LINUX_GIT_REF_REPO_DIR="$HOME/gitcache/linux-stable.git/"
+
+OBJ_STORE_URL="s3://jenkins"
+
+cd "$WORKSPACE"
+
+# Create build directories
+mkdir -p "${LINUX_SRCOBJ_DIR}" "${LINUX_HDROBJ_DIR}" "${LINUX_INSTOBJ_DIR}" "${MODULES_OUTPUT_KSRC_DIR}" "${MODULES_OUTPUT_KHDR_DIR}"
+
+git_clone_modules_sources
 
 # Setup cross compile env if available
 if [ "x${cross_arch}" != "x" ]; then
@@ -221,15 +472,10 @@ if [ "x${cross_arch}" != "x" ]; then
             ;;
     esac
 
-    # Use gcc 4.9, older kernel don't build with gcc 5
-    CC="${cross_compile}gcc-4.9"
-
     # Export variables used by Kbuild for cross compilation
     export ARCH="${karch}"
     export CROSS_COMPILE="${cross_compile}"
 
-    oldconf_target="olddefconfig"
-
 # Set arch specific values if we are not cross compiling
 elif [ "x${arch}" != "x" ]; then
 
@@ -275,12 +521,6 @@ elif [ "x${arch}" != "x" ]; then
             exit 1
             ;;
     esac
-
-    # Use gcc 4.9, older kernel don't build with gcc 5
-    CC=gcc-4.9
-
-    oldconf_target="silentoldconfig"
-
 else
     echo "Not arch or cross_arch specified"
     exit 1
@@ -288,130 +528,89 @@ fi
 
 
 
+# First get the kernel build from the object store, or build it, if it's
+# not available.
 
-# Create build directories
-mkdir -p "${LNXBUILDDIR}" "${LNXHDRDIR}" "${LTTBUILDKSRCDIR}" "${LTTBUILDKHDRDIR}"
+echo "# Setup endpoint
+host_base = obj.internal.efficios.com
+host_bucket = obj.internal.efficios.com
+bucket_location = us-east-1
+use_https = True
 
+# Setup access keys
+access_key = jenkins
+secret_key = echo123456
 
+# Enable S3 v4 signature APIs
+signature_v2 = False" > "$WORKSPACE/.s3cfg"
 
-## PREPARE DISTRO STYLE KERNEL HEADERS / DEVEL
+url_hash="$(echo -n "$kgitrepo/$ktag/$arch/$cross_arch" | md5sum | awk '{ print $1 }')"
+obj_name="linux.tar.bz2"
+obj_url_prefix="$OBJ_STORE_URL/linux-build/$url_hash"
+obj_url="$obj_url_prefix/$obj_name"
 
-# Enter linux source dir
-cd "${LNXSRCDIR}"
+set +e
+s3cmd -c "$WORKSPACE/.s3cfg" get "$obj_url"
+ret=$?
+set -e
 
-# Get kernel version from source tree
-KVERSION=$(make kernelversion)
+case "$ret" in
+    "0")
+      extract_archive_obj
+      ;;
 
-prepare_lnx_sources "."
+    "12")
+      echo "File not found"
 
-# For RT kernels, copy version file
-if [ -s localversion-rt ]; then
-    cp -a localversion-rt "${LNXHDRDIR}"
-fi
+      # Build all the things and upload
+      # then finish the module build...
 
-# Copy all Makefile related stuff
-find . -path './include/*' -prune \
-    -o -path './scripts/*' -prune -o -type f \
-       \( -name 'Makefile*' -o -name 'Kconfig*' -o -name 'Kbuild*' -o \
-        -name '*.sh' -o -name '*.pl' -o -name '*.lds' \) \
-    -print | cpio -pd --preserve-modification-time "${LNXHDRDIR}"
-
-# Copy base scripts and include dirs
-cp -a scripts include "${LNXHDRDIR}"
-
-# Copy arch includes
-(find arch -name include -type d -print0 | \
-    xargs -0 -n1 -i: find : -type f) | \
-       cpio -pd --preserve-modification-time "${LNXHDRDIR}"
-
-# Copy arch scripts
-(find arch -name scripts -type d -print0 | \
-    xargs -0 -n1 -i: find : -type f) | \
-       cpio -pd --preserve-modification-time "${LNXHDRDIR}"
-
-# Cleanup scripts
-rm -f "${LNXHDRDIR}/scripts/*.o"
-rm -f "${LNXHDRDIR}/scripts/*/*.o"
-
-# On powerpc this object is required to link modules
-if [ "${karch}" = "powerpc" ]; then
-    cp -a --parents arch/powerpc/lib/crtsavres.[So] "${LNXHDRDIR}/"
-fi
+      git_clone_linux_sources
+      git_export_linux_sources
 
-# On arm64 between 4.13 and 1.15 this object is required to build with ftrace support
-if [ "${karch}" = "arm64" ]; then
-    if [ -f "arch/arm64/kernel/ftrace-mod.S" ]; then
-        cp -a --parents arch/arm64/kernel/ftrace-mod.[So] "${LNXHDRDIR}/"
-    fi
-fi
+      select_compiler
 
-# Newer kernels need objtool to build modules when CONFIG_STACK_VALIDATION=y
-if [ -f tools/objtool/objtool ]; then
-  cp -a --parents tools/objtool/objtool "${LNXHDRDIR}/"
-fi
+      ## PREPARE FULL LINUX SOURCE TREE
+      build_linux_kernel
 
-# Copy modules related stuff, if available
-if [ -s Module.symvers ]; then
-    cp Module.symvers "${LNXHDRDIR}"
-fi
-
-if [ -s System.map ]; then
-    cp System.map "${LNXHDRDIR}"
-fi
-
-if [ -s Module.markers ]; then
-    cp Module.markers "${LNXHDRDIR}"
-fi
+      ## EXTRACT DISTRO STYLE KERNEL HEADERS / DEVEL
+      extract_distro_headers
 
-# Copy config file
-cp .config "${LNXHDRDIR}"
+      tar_archive_obj
 
-# Make sure the Makefile and version.h have a matching timestamp so that
-# external modules can be built
-if [ -s "${LNXHDRDIR}/include/generated/uapi/linux/version.h" ]; then
-    touch -r "${LNXHDRDIR}/Makefile" "${LNXHDRDIR}/include/generated/uapi/linux/version.h"
-elif [ -s "${LNXHDRDIR}/include/linux/version.h" ]; then
-    touch -r "${LNXHDRDIR}/Makefile" "${LNXHDRDIR}/include/linux/version.h"
-else
-    echo "Missing version.h"
-    exit 1
-fi
-touch -r "${LNXHDRDIR}/.config" "${LNXHDRDIR}/include/generated/autoconf.h"
+      upload_archive_obj
 
-# Copy .config to include/config/auto.conf so "make prepare" is unnecessary.
-cp "${LNXHDRDIR}/.config" "${LNXHDRDIR}/include/config/auto.conf"
+      ;;
 
+    *)
+      echo "Unknown error? Abort"
+      exit 1
+      ;;
+esac
 
-
-
-## PREPARE FULL LINUX SOURCE TREE
-
-# Enter linux source dir
-cd "${LNXSRCDIR}"
-
-# Make sure linux source dir is clean
-git clean -xdf
-
-prepare_lnx_sources "${LNXBUILDDIR}"
-
+select_compiler
 
 ## BUILD modules
+# Either we downloaded a pre-build kernel or we built it and uploaded
+# the archive for future builds.
+
+cd "$WORKSPACE"
 
 # Build modules against full kernel sources
-build_modules "${LNXBUILDDIR}" "${LTTBUILDKSRCDIR}"
+build_modules "${LINUX_SRCOBJ_DIR}" "${MODULES_OUTPUT_KSRC_DIR}"
 
 # Build modules against kernel headers
-build_modules "${LNXHDRDIR}" "${LTTBUILDKHDRDIR}"
+build_modules "${LINUX_HDROBJ_DIR}" "${MODULES_OUTPUT_KHDR_DIR}"
 
-# Make sure modules were built
-tree "${LTTBUILDKSRCDIR}"
-if [ "x$(find "${LTTBUILDKSRCDIR}" -name '*.ko*' -printf yes -quit)" != "xyes" ]; then
+# Make sure some modules were actually built
+tree "${MODULES_OUTPUT_KSRC_DIR}"
+if [ "x$(find "${MODULES_OUTPUT_KSRC_DIR}" -name '*.ko*' -printf yes -quit)" != "xyes" ]; then
   echo "No modules built!"
   exit 1
 fi
 
-tree "${LTTBUILDKHDRDIR}"
-if [ "x$(find "${LTTBUILDKHDRDIR}" -name '*.ko*' -printf yes -quit)" != "xyes" ]; then
+tree "${MODULES_OUTPUT_KHDR_DIR}"
+if [ "x$(find "${MODULES_OUTPUT_KHDR_DIR}" -name '*.ko*' -printf yes -quit)" != "xyes" ]; then
   echo "No modules built!"
   exit 1
 fi
This page took 0.037914 seconds and 4 git commands to generate.